/* util.c generated by valac 0.42.7, the Vala compiler
 * generated from util.vala, do not modify */



#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>




glong xmpp_util_from_hex (const gchar* numeral);


/**
  * Parse a number from a hexadecimal representation.
  *
  * Skips any whitespace at the start of the string, parses as many valid
  * characters as hexadecimal digits as possible (possibly zero) and returns
  * them as an integer value.
  *
  * ```
  * // 0xa
  * print("0x%lx\n", from_hex("A quick brown fox jumps over the lazy dog."));
  * ```
  */
static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1499 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1499 "glib-2.0.vapi"
	res_length1 = -1;
#line 1499 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1501 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1501 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1501 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1501 "glib-2.0.vapi"
	if (result_length1) {
#line 1501 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 70 "util.c"
	}
#line 1501 "glib-2.0.vapi"
	result = _tmp3_;
#line 1501 "glib-2.0.vapi"
	return result;
#line 76 "util.c"
}


glong
xmpp_util_from_hex (const gchar* numeral)
{
	glong result = 0L;
	glong _result_ = 0L;
	gboolean skipping_whitespace = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 16 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	g_return_val_if_fail (numeral != NULL, 0L);
#line 17 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	_result_ = (glong) 0;
#line 18 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	skipping_whitespace = TRUE;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	_tmp0_ = string_get_data (numeral, &_tmp0__length1);
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	_tmp1_ = _tmp0_;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	_tmp1__length1 = _tmp0__length1;
#line 102 "util.c"
	{
		guint8* byte_collection = NULL;
		gint byte_collection_length1 = 0;
		gint _byte_collection_size_ = 0;
		gint byte_it = 0;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
		byte_collection = _tmp1_;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
		byte_collection_length1 = _tmp1__length1;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
		for (byte_it = 0; byte_it < _tmp1__length1; byte_it = byte_it + 1) {
#line 114 "util.c"
			guint8 byte = 0U;
#line 19 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
			byte = byte_collection[byte_it];
#line 118 "util.c"
			{
				gchar c = '\0';
				guint8 _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_;
				gint digit = 0;
				gboolean _tmp6_ = FALSE;
				gchar _tmp7_;
				glong _tmp18_;
				gint _tmp19_;
#line 20 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_tmp2_ = byte;
#line 20 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				c = (gchar) _tmp2_;
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_tmp4_ = skipping_whitespace;
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				if (_tmp4_) {
#line 137 "util.c"
					gchar _tmp5_;
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp5_ = c;
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp3_ = g_ascii_isspace (_tmp5_);
#line 143 "util.c"
				} else {
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp3_ = FALSE;
#line 147 "util.c"
				}
#line 21 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				if (_tmp3_) {
#line 22 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					continue;
#line 153 "util.c"
				}
#line 24 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				skipping_whitespace = FALSE;
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_tmp7_ = c;
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				if ('0' <= _tmp7_) {
#line 161 "util.c"
					gchar _tmp8_;
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp8_ = c;
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp6_ = _tmp8_ <= '9';
#line 167 "util.c"
				} else {
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp6_ = FALSE;
#line 171 "util.c"
				}
#line 26 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				if (_tmp6_) {
#line 175 "util.c"
					gchar _tmp9_;
#line 27 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp9_ = c;
#line 27 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					digit = (gint) (_tmp9_ - '0');
#line 181 "util.c"
				} else {
					gboolean _tmp10_ = FALSE;
					gchar _tmp11_;
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					_tmp11_ = c;
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					if ('A' <= _tmp11_) {
#line 189 "util.c"
						gchar _tmp12_;
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						_tmp12_ = c;
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						_tmp10_ = _tmp12_ <= 'F';
#line 195 "util.c"
					} else {
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						_tmp10_ = FALSE;
#line 199 "util.c"
					}
#line 28 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
					if (_tmp10_) {
#line 203 "util.c"
						gchar _tmp13_;
#line 29 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						_tmp13_ = c;
#line 29 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						digit = (_tmp13_ - 'A') + 10;
#line 209 "util.c"
					} else {
						gboolean _tmp14_ = FALSE;
						gchar _tmp15_;
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						_tmp15_ = c;
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						if ('a' <= _tmp15_) {
#line 217 "util.c"
							gchar _tmp16_;
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							_tmp16_ = c;
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							_tmp14_ = _tmp16_ <= 'f';
#line 223 "util.c"
						} else {
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							_tmp14_ = FALSE;
#line 227 "util.c"
						}
#line 30 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
						if (_tmp14_) {
#line 231 "util.c"
							gchar _tmp17_;
#line 31 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							_tmp17_ = c;
#line 31 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							digit = (_tmp17_ - 'a') + 10;
#line 237 "util.c"
						} else {
#line 33 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
							break;
#line 241 "util.c"
						}
					}
				}
#line 35 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_tmp18_ = _result_;
#line 35 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_tmp19_ = digit;
#line 35 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
				_result_ = (_tmp18_ << 4) | _tmp19_;
#line 251 "util.c"
			}
		}
	}
#line 37 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	result = _result_;
#line 37 "/builddir/build/BUILD/dino-f746ce74ce6e905483d86b603df01b81acbca7b4/xmpp-vala/src/util.vala"
	return result;
#line 259 "util.c"
}



